﻿/*
 *! @brief          Hauptprogramm des C#-Beispiels
 *
 *! @author         Markus Biggel
 * letzte Aenderung 31.05.2009
 *
 *! @addtogroup csharpusage Verwendung in C#
 *! @file Beispiele/UsageInC-Sharp/src/Program.cs
 *! @ingroup csharpusage csharp
 */
using System;
using System.Windows.Forms;


namespace keypilot
{
    /// <summary>
    /// Class with program entry point.
    /// </summary>
    internal sealed class Program
    {
        /// <summary>
        /// Program entry point.
        /// </summary>
        [STAThread]
        private static void Main(string[] args)
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new MainForm());
        }

    }
}
