VERSION 5.00
Begin VB.Form KP_Form 
   Caption         =   "Form1"
   ClientHeight    =   7080
   ClientLeft      =   7695
   ClientTop       =   3930
   ClientWidth     =   10380
   LinkTopic       =   "Form1"
   ScaleHeight     =   7080
   ScaleWidth      =   10380
   Begin VB.CommandButton KP_ScanDevices 
      Caption         =   "Scan USB Devices"
      Height          =   375
      Left            =   2280
      TabIndex        =   15
      ToolTipText     =   "KP_ScanDevices"
      Top             =   600
      Width           =   1695
   End
   Begin VB.CommandButton KP_GetLastErrorButton 
      Caption         =   "Get Last Error"
      Height          =   375
      Left            =   9000
      TabIndex        =   14
      ToolTipText     =   "KP_GetLastErrorButton"
      Top             =   3360
      Width           =   1215
   End
   Begin VB.TextBox KP_SelectPage 
      Alignment       =   1  'Right Justify
      Height          =   375
      Left            =   5400
      TabIndex        =   12
      Text            =   "0"
      ToolTipText     =   "KP_SelectPage"
      Top             =   3360
      Width           =   375
   End
   Begin VB.CommandButton ReadDataButton 
      Caption         =   "Read Data Page:"
      Height          =   375
      Left            =   3840
      TabIndex        =   10
      ToolTipText     =   "ReadDataButton"
      Top             =   3360
      Width           =   1455
   End
   Begin VB.CommandButton WrDataButton 
      Caption         =   "WriteData"
      Height          =   375
      Left            =   9000
      TabIndex        =   9
      ToolTipText     =   "WrDataButton"
      Top             =   2880
      Width           =   1215
   End
   Begin VB.TextBox DataToWrite 
      Height          =   2295
      Left            =   4080
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   8
      ToolTipText     =   "DataToWrite"
      Top             =   480
      Width           =   6135
   End
   Begin VB.CommandButton GetKeyID 
      Caption         =   "Get Key ID"
      Height          =   375
      Left            =   120
      TabIndex        =   4
      ToolTipText     =   "GetKeyID"
      Top             =   1080
      Width           =   1095
   End
   Begin VB.CommandButton RedLedButton 
      Caption         =   "Red LED"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      ToolTipText     =   "RedLedButton"
      Top             =   2040
      Width           =   1095
   End
   Begin VB.CommandButton GreenLedButton 
      Caption         =   "Green LED"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      ToolTipText     =   "GreenLedButton"
      Top             =   1560
      Width           =   1095
   End
   Begin VB.ComboBox KP_Select 
      Height          =   315
      Left            =   1320
      TabIndex        =   0
      Text            =   "Select"
      ToolTipText     =   "KP_Select"
      Top             =   600
      Width           =   855
   End
   Begin VB.Label LibraryLabel 
      Height          =   255
      Left            =   120
      TabIndex        =   13
      ToolTipText     =   "LibraryLabel"
      Top             =   120
      Width           =   2415
   End
   Begin VB.Label KP_PagesInfo 
      Height          =   255
      Left            =   3840
      TabIndex        =   11
      ToolTipText     =   "KP_PagesInfo"
      Top             =   2880
      Width           =   2295
   End
   Begin VB.Line Line8 
      X1              =   3840
      X2              =   3840
      Y1              =   3840
      Y2              =   6840
   End
   Begin VB.Line Line7 
      X1              =   3840
      X2              =   10200
      Y1              =   6840
      Y2              =   6840
   End
   Begin VB.Line Line6 
      X1              =   10200
      X2              =   10200
      Y1              =   6840
      Y2              =   3840
   End
   Begin VB.Line Line4 
      X1              =   3840
      X2              =   10200
      Y1              =   3840
      Y2              =   3840
   End
   Begin VB.Label KP_Pages 
      Height          =   2775
      Left            =   3960
      TabIndex        =   7
      ToolTipText     =   "KP_Pages"
      Top             =   3960
      Width           =   6135
      WordWrap        =   -1  'True
   End
   Begin VB.Label KP_Sel_Label 
      Caption         =   "USB Device ID"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      ToolTipText     =   "KP_Sel_Label"
      Top             =   600
      Width           =   1095
   End
   Begin VB.Label KeyID 
      Height          =   1815
      Left            =   1320
      TabIndex        =   5
      ToolTipText     =   "KeyID"
      Top             =   1080
      Width           =   2055
   End
   Begin VB.Line Line5 
      X1              =   3720
      X2              =   3720
      Y1              =   3240
      Y2              =   6840
   End
   Begin VB.Line Line3 
      X1              =   3720
      X2              =   120
      Y1              =   6840
      Y2              =   6840
   End
   Begin VB.Line Line2 
      X1              =   120
      X2              =   120
      Y1              =   6840
      Y2              =   3240
   End
   Begin VB.Line Line1 
      X1              =   120
      X2              =   3720
      Y1              =   3240
      Y2              =   3240
   End
   Begin VB.Label KP_Label 
      Caption         =   "KeyPilot Information (KEYPILOT_USB_DEVICE):"
      Height          =   3375
      Left            =   240
      TabIndex        =   1
      ToolTipText     =   "KP_Label"
      Top             =   3360
      Width           =   3375
   End
End
Attribute VB_Name = "KP_Form"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
    'Beispielprogramm zur Verwendung der KeyPilot-USBDLL unter VB6
    '
    'erstellt am: 02.06.2009
    'erstellt von: A. Fahrenkrog
    '
    'Sysdesign GmbH
    'Saentisstrasse 25
    '88079 Kressbronn
    
    'Definitionen von globalen Variablen. Diese Variablen werden
    'von den verschiedenen Elementen in der Hauptform verwendet
    Dim KeyPilotDevice As KEYPILOT_USB_DEVICE
    Dim KeyPilotList() As KEYPILOT_USB_DEVICE
    Dim KeyData As KEYPILOT_KEYDATA
    
    Dim Fehler As Long
    Dim dummy As Long
    Dim ErrorString(0 To KP_ERRSTRING_LENGTH - 1) As Byte
    
    Dim anzahlKPs As Long
    Dim selectedDevice As Long
    
    Dim pageSize As Long
    Dim pageData() As Byte
    Dim pageAmount As Long
    
    Dim LibraryVersion(0 To DLL_VERSION_LENGTH - 1) As Byte
    
    'Hilfsvariable fr Do - While loops
    Dim X As Long

Private Sub DataToWrite_Change()
    
    'Hier werden als Text die Daten eingegeben die zum KeyPilot
    'geschrieben werden mssen. Diese Funktion wird aufgerufen
    'wenn sich ein Zeichen ndert, bzw. bei jedem Tastendruck
    'Ein Anzeiger wird aktualisiert; der zeigt wieviele
    'bytes und pages geschrieben werden.
    
    Dim temp As String
    Dim tempBytes() As Byte
    Dim dataBytes As Integer
    Dim dataPages As Integer
    
    tempBytes = StrConv(DataToWrite.Text, vbFromUnicode)
    
    'Byteanzahl wird gelesen
    dataBytes = UBound(tempBytes) + 1
    
    'Wenn mehr Bytes geschrieben werden als eine Page enthalten
    'kann, wird die Anzahl der Pages erhht
    If (pageSize > 0) Then
        dataPages = (dataBytes - 1) \ pageSize
        temp = "Bytes: " & CStr(dataBytes) & ", Pages: " & CStr(dataPages + 1)
    Else
        temp = "Bytes: " & CStr(dataBytes)
    End If
    
    KP_PagesInfo.Caption = temp
    
End Sub

Private Sub Form_Load()
    'Diese Funktion wird am Anfang des Programms aufgerufen. Hier wird das
    'Hauptfenster angezeigt und die USB Devices werden gescant und die Anzahl an
    'verbundenen Devices wird festgelegt.
    'Schliesslich wird die LibraryVersion im Fenster angezeigt (DLL)
        
    'Kein USB Device ist am Anfang des Programms
    'gewhlt worden
    selectedDevice = -1
    
    'Scannen der angeschlossenen USB-Geraete
    'Wenn ein Fehler trifft, wird der Fehler angezeigt
    'und das Programm danach beendet
    Fehler = kpUSBScanDevices()
    If (Fehler <> KP_OK) Then
        dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
        MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
        End 'Beendet das Programm
    End If

    'Abfragen wieviele KeyPilot Geraete erkannt wurden
    'Ist kein KeyPilot angeschlossen, so wird keine information
    'angezeigt bis ein Gert angelschlossen wird
    anzahlKPs = kpUSBGetNumberOfDevices()
    X = 0
    If (anzahlKPs = 0) Then
        KP_Select.Enabled = False
    Else
        ReDim KeyPilotList(0 To anzahlKPs - 1)
        Do While X < anzahlKPs
            Fehler = kpUSBGetDeviceListIndex(KeyPilotList(X), X)
            If (Fehler <> KP_OK) Then
                dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
                MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
            End 'Beendet das Programm
            End If
            KP_Select.AddItem (CStr(KeyPilotList(X).deviceID))
            X = X + 1
        Loop
    End If
    
    'Beim Starten des programms sind alle Buttons deaktiviert
    'Sie werden aktiviert wenn die entsprechende KeyPilots gefunden werden
    GreenLedButton.Enabled = False
    RedLedButton.Enabled = False
    GetKeyID.Enabled = False
    ReadDataButton.Enabled = False
    WrDataButton.Enabled = False
    
    'Am Anfang gibt es keine Key Pages
    pageSize = 0
    pageAmount = 0
    
    'Die Library Version wird gelesen und in der Form gezeigt
    Fehler = kpUSBGetLibraryVersion(LibraryVersion(0), 32)
    If (Fehler <> KP_OK) Then
        dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
        MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
    Else
        LibraryLabel.Caption = "Library Version : " & ByteArrayToString(LibraryVersion)
    End If
    
    KP_Form.Caption = "USB KeyPilot VisualBasic 6 Demo"
        
End Sub

Private Sub GetKeyID_Click()

    'Diese Funktion wird aufgerufen wenn auf das "Get Key ID" Knopf gedruckt wird
    'Hier werden die Daten des eingesteckten Keys angezeigt.
    'Wenn kein Key aufgelegt ist, kommt eine Fehlermeldung
    
    Dim readKey As String
    Dim pageInfo As String
    Dim temp As String
    
    'Hier wird die Information vom Key in der KeyData Variable gelesen
    'Anschliessend wird die Information in dem Label angezeigt
    Fehler = kpUSBGetKeyID(selectedDevice, KeyData)
    If (Fehler <> KP_OK) Then
        dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
        MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
    Else
        readKey = "Valid Data: " & CStr(KeyData.validData)
        If KeyData.validData = 1 Then
            readKey = readKey & " (Valid)" & vbNewLine
        Else
            readKey = readKey & " (Invalid)" & vbNewLine
        End If
        readKey = readKey & "Command: " & ByteArrayToString(KeyData.command) & vbNewLine
        readKey = readKey & "Key ID: " & ByteArrayToString(KeyData.KeyID) & vbNewLine
        readKey = readKey & "Family Code: " & ByteArrayToString(KeyData.famCode) & vbNewLine
        readKey = readKey & "CRC: " & ByteArrayToString(KeyData.crc) & vbNewLine
        KeyID.Caption = readKey
    End If
    
    'Hier wird die Information zur PageSize vom Key Gelesen
    'Anschliessend wird die Information in dem Label angezeigt
    pageSize = kpUSBGetKeyPageSize(selectedDevice)
    If (pageSize = 0) Then
        pageInfo = "Key on pilot is read-only"
    ElseIf (pageSize < 0) Then
        dummy = kpUSBGetErrorString(pageSize, ErrorString(0), UBound(ErrorString) + 1)
        MsgBox ("Error #" & CStr(pageSize) & vbNewLine & ByteArrayToString(ErrorString))
    Else
        pageInfo = "Page Size: " & CStr(pageSize)
    End If
    
    KeyID.Caption = KeyID.Caption & vbNewLine & pageInfo
    
    'Hier wird die Anzahl von Pages des Keys gelesen, nur wenn es
    'frher eine gltige Pagesize gefunden hat
    'Wenn es eine gltige Pagesize gab, wird die Anzahl in
    'dem Label angezeigt
    If (pageSize > 0) Then
        pageAmount = kpUSBGetNrOfPages(selectedDevice)
        If (pageAmount = 0) Then
            pageInfo = "No pages on key"
        ElseIf (pageAmount < 0) Then
            dummy = kpUSBGetErrorString(pageAmount, ErrorString(0), UBound(ErrorString) + 1)
            MsgBox ("Error #" & CStr(pageAmount) & vbNewLine & ByteArrayToString(ErrorString))
        Else
            pageInfo = "Amount of pages: " & CStr(pageAmount)
        End If
        KeyID.Caption = KeyID.Caption & vbNewLine & pageInfo
    End If
    
End Sub

Private Sub GreenLedButton_Click()
    'Diese Funktion wird aufgerufen wenn das "Green LED"
    'Knopf gedrckt wird.
    
    'Per Knopfdurck wird die grne LED beim gewhlten
    'Keypilot fr 500 ms aktiviert, wenn der Keypilot existiert
    Fehler = kpUSBDoesDeviceExist(selectedDevice)
    If (Fehler <> KP_OK) Then
        dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
        MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
    Else
        Fehler = kpUSBSetLED(KeyPilotDevice.deviceID, KP_LED_COLOR_GREEN)
        If (Fehler <> KP_OK) Then
            dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
            MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
        End If
    End If
    
End Sub

Private Sub KP_GetLastErrorButton_Click()
    'Diese Funktion wird aufgerufen wenn das "Get Last Error" Knopf gedrckt wird.
    'Sie zeigt den letzten Fehler an.
    
    Fehler = kpUSBGetLastError()
    dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
    MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
    
End Sub

Private Sub KP_Select_Click()
    'Diese Funktion wird aktiviert wenn in der KP_Select Combobox
    'neues KeyPilot USB Device ausgewhlt wird.
    
    Dim choice As Integer
    Dim FWVersion(0 To KP_FIRMWARE_VERSION_LENGTH - 1) As Byte
    Dim SerNumber(0 To SERIAL_NUMBER_LENGTH - 1) As Byte
    Dim ConnStatus As Long
    
    KeyID.Caption = ""
    KP_Pages.Caption = ""
    
    choice = KP_Select.ListIndex
    
    'Wenn ein neues KeyPilot gewhlt wird muss der letzte KeyPilot
    'erstmals getrennt werden, die DeviceID vom gewhlten KeyPilot
    'wird gespeichert und eine Verbindung zum neuen KeyPilot wird
    'hergestellt
    If (selectedDevice <> -1) Then
        If (KeyPilotList(choice).deviceID <> selectedDevice) Then
            
            Fehler = kpUSBDisconnectFromDevice(selectedDevice)
            If (Fehler <> KP_OK) Then
                dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
                MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
            End If
            
            selectedDevice = KeyPilotList(choice).deviceID
            Fehler = kpUSBConnectToDevice(selectedDevice)
            If (Fehler <> KP_OK) Then
                dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
                MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
            End If
            
        End If
    'Wenn ein Keypilot am Anfang gewhlt wird, muss man den frheren KeyPilot nicht
    'trennen
    Else
    
        selectedDevice = KeyPilotList(choice).deviceID
        Fehler = kpUSBConnectToDevice(selectedDevice)
        
        If (Fehler <> KP_OK) Then
            dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
            MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
        End If
    End If
    
    'Die Information zum gewhlten Device werden in der
    'KeyPilotDevice Variable gespeichert. Die Daten werden
    'mittels kpUSBGetDevice ausgelesen
    Fehler = kpUSBGetDevice(selectedDevice, KeyPilotDevice)
    If (Fehler <> KP_OK) Then
        dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
        MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
    End If
    
    If (KeyPilotDevice.connectionStatus = AVAILABLE) Then
        Fehler = kpUSBConnectToDevice(selectedDevice)
        If (Fehler <> KP_OK) Then
            dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
            MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
        End If
    End If
    
    
    'Wenn ein KeyPilot gefunden wurde, werden die verschiedene
    'Knpfe aktiviert
    GreenLedButton.Enabled = True
    RedLedButton.Enabled = True
    GetKeyID.Enabled = True
    ReadDataButton.Enabled = True
    WrDataButton.Enabled = True
    
    'Die Information des KeyPilots wird ausgegeben
    KP_Label.Caption = "KeyPilot Information (KEYPILOT_USB_DEVICE):"
    KP_Label.Caption = KP_Label.Caption & GetKPInformation(KeyPilotDevice)
    
    'Die Firmware und SerienNummer wird mit den anderen Funktionen
    'wiederholt gelesen und angezeigt
    Fehler = kpUSBGetFirmwareVersion(selectedDevice, FWVersion(0), UBound(FWVersion) + 1)
    If (Fehler <> KP_OK) Then
        dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
        MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
    End If
    
    KP_Label.Caption = KP_Label.Caption & vbNewLine & vbNewLine & "From Read Functions:"
    KP_Label.Caption = KP_Label.Caption & vbNewLine & "Firmware: " & ByteArrayToString(FWVersion)
    
    Fehler = kpUSBGetSerialNumber(selectedDevice, SerNumber(0), UBound(SerNumber) + 1)
    If (Fehler <> KP_OK) Then
        dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
        MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
    End If
    KP_Label.Caption = KP_Label.Caption & vbNewLine & "Serial Number: " & ByteArrayToString(SerNumber)
    
End Sub


Private Sub RedLedButton_Click()
    'Diese Funktion wird aufgerufen wenn das "Red LED"
    'Knopf gedrckt wird.

    'Per Knopfdurck wird die rote LED beim gewhlten
    'Keypilot fr 500 ms aktiviert, wenn der Keypilot existiert
    Fehler = kpUSBDoesDeviceExist(selectedDevice)
    If (Fehler <> KP_OK) Then
        dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
        MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
    Else
        Fehler = kpUSBSetLED(KeyPilotDevice.deviceID, KP_LED_COLOR_RED)
        If (Fehler <> KP_OK) Then
            dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
            MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
        End If
    End If
End Sub

Private Sub KP_ScanDevices_Click()

    Dim neueAnzahlKps As Long
    
    'Diese Funktion wird aufgerufen wenn der KP_ScanDevices Knopf
    'gedrckt wird. Es prft ob ein KP angeschlossen oder
    'getrennt wurde.
    'Ist das der Fall, wird die Liste der KeyPilots aktualisiert
    
    Fehler = kpUSBScanDevices()
    If (Fehler <> KP_OK) Then
        dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
        MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
        End 'Beendet das Programm
    End If
    
    neueAnzahlKps = kpUSBGetNumberOfDevices()
    If (neueAnzahlKps < KP_OK) Then
        dummy = kpUSBGetErrorString(neueAnzahlKps, ErrorString(0), UBound(ErrorString) + 1)
        MsgBox ("Error #" & CStr(neueAnzahlKps) & vbNewLine & ByteArrayToString(ErrorString))
        End 'Beendet das Programm
    End If
    
    'Abfragen wieviele KeyPilot Geraete erkannt wurden
    'Ist kein KeyPilot angeschlossen, so wird keine information
    'angezeigt bis ein Gert angelschlossen wird
    'Wenn sich die Anzahl der KPs gendert hat wird es wie
    'ein Neustart behandelt -> selectedDevice = -1
    If (anzahlKPs <> neueAnzahlKps) Then
        'Wenn ein KP getrennt oder hinzugefgt wird
        'aktualisieren sich die Anzeiger
        anzahlKPs = neueAnzahlKps
        KP_Select.Clear
        KP_Label.Caption = "KeyPilot Information"
        KP_Pages.Caption = ""
        X = 0
        selectedDevice = -1
        
        'Ist kein KeyPilot vorhanden, werden die Knpfe
        'deaktiviert
        If (anzahlKPs = 0) Then
            KP_Select.Enabled = False
            KP_Label.Enabled = False
            GreenLedButton.Enabled = False
            RedLedButton.Enabled = False
            GetKeyID.Enabled = False
            ReadDataButton.Enabled = False
            WrDataButton.Enabled = False
        'Werden 1 oder mehr KeyPilots gefunden, so wird die DropDown Liste
        'Erneut aktualisisert
        Else
            KP_Select.Enabled = True
            KP_Label.Enabled = True
            ReDim KeyPilotList(0 To anzahlKPs - 1)
            Do While X < anzahlKPs
                Fehler = kpUSBGetDeviceListIndex(KeyPilotList(X), X)
                If (Fehler <> KP_OK) Then
                    dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
                    MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
                End 'Beendet das Programm
                End If
                KP_Select.AddItem (CStr(KeyPilotList(X).deviceID))
                X = X + 1
            Loop
        End If
    Else
    'Wenn sich nichts gendert hat wird nichts getan
    End If
    
End Sub

Private Sub WrDataButton_Click()
    
    'Diese Funktion wird aufgerufen wenn Daten in einem Key
    'geschrieben werden sollen
    Dim byteArray() As Byte
    Dim tempPages As Integer
    Dim newByteArray() As Byte
    
    'Das Text wird als byte array gespeichert
    byteArray = StrConv(DataToWrite.Text, vbFromUnicode)
    
    Fehler = kpUSBGetKeyID(selectedDevice, KeyData)
    If (Fehler <> KP_OK) Then
        dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
        MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
    End If
    
    'Die PageSize vom key wird ausgelesen
    pageSize = kpUSBGetKeyPageSize(selectedDevice)
    If (pageSize < 0) Then
        dummy = kpUSBGetErrorString(pageSize, ErrorString(0), UBound(ErrorString) + 1)
        MsgBox ("Error #" & CStr(pageSize) & vbNewLine & ByteArrayToString(ErrorString))
    ElseIf (pageSize > 0) Then
        'Wenn die Pagesize > 0 dann wird geprft ob es Daten zu schreiben gibt
        If (UBound(byteArray) <> -1) Then
            'Wenn die Daten ein ganzzhliges Vielfaches von Pages entsprechen, werden
            'die ganzen pages geschrieben
            If (UBound(byteArray) + 1) Mod pageSize = 0 Then
                tempPages = (UBound(byteArray) + 1) \ pageSize
                Fehler = kpUSBWritePagesToKey(selectedDevice, tempPages, byteArray(0), tempPages * pageSize)
                If (Fehler <> KP_OK) Then
                    dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
                    MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
                End If
            'Wenn die Daten keine vollstndige Pages fllen, wird die letzte Page mit
            'Nullen gefllt
            Else
                tempPages = (UBound(byteArray) + 1) \ pageSize + 1
                ReDim newByteArray(0 To (tempPages * pageSize - 1)) As Byte
                
                For i = LBound(byteArray) To UBound(byteArray)
                    newByteArray(i) = byteArray(i)
                Next i
                
                For i = (UBound(byteArray) + 1) To UBound(newByteArray)
                    newByteArray(i) = 0
                Next i
                
                Fehler = kpUSBWritePagesToKey(selectedDevice, tempPages, newByteArray(0), tempPages * pageSize)
                If (Fehler <> KP_OK) Then
                    dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
                    MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
                End If
            End If
        Else
            MsgBox ("No data to write")
        End If
    'Wenn das Key keine Pages enthlt, werden keine Daten geschrieben
    Else
        MsgBox ("Key is Read-Only")
    End If
    
    DataToWrite.Text = ""
    KP_PagesInfo.Caption = ""
    
    
End Sub

Private Sub ReadDataButton_Click()
    'Diese Funktion wird aufgerufen wenn die Daten vom Key
    'gelesen werden sollen
    Dim pageInfo As String
    Dim tempPage As Long
    
    Fehler = kpUSBGetKeyID(selectedDevice, KeyData)
    If (Fehler <> KP_OK) Then
        dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
        MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
    End If
    
    pageSize = kpUSBGetKeyPageSize(selectedDevice)
    If (pageSize < 0) Then
        dummy = kpUSBGetErrorString(pageSize, ErrorString(0), UBound(ErrorString) + 1)
        MsgBox ("Error #" & CStr(pageSize) & vbNewLine & ByteArrayToString(ErrorString))
    End If
        
    'Diese Variable dient zur Wahl der Page die ausgelesen
    'werden soll.
    tempPage = CInt(KP_SelectPage.Text)
    
    
    If (KeyData.validData <> 0) Then
        If pageSize > 0 Then
            ReDim pageData(0 To pageSize - 1)
            
            'Wenn ein gltiger Key mit Daten am KeyPilot steckt, werden die Daten ausgelesen
            Fehler = kpUSBReadPageFromKey(selectedDevice, tempPage, pageData(0), pageSize)
            If (Fehler <> KP_OK) Then
                dummy = kpUSBGetErrorString(Fehler, ErrorString(0), UBound(ErrorString) + 1)
                MsgBox ("Error #" & CStr(Fehler) & vbNewLine & ByteArrayToString(ErrorString))
            Else
                'Zuerst werden die Daten als Hexzeichen gezeigt
                For i = 0 To pageSize - 1
                    temp = temp & byte2hex(pageData(i))
                    temp = temp & " "
                Next i
                
                KP_Pages.Caption = temp
                
                temp = ""
                
                'Anschliessend werden die Daten als 'Chars' angezeigt
                'und durch ein Leerzeichen getrennt
                For i = 0 To pageSize - 1
                    If (pageData(i) <> 0) Then
                        temp = temp & Chr(pageData(i))
                        temp = temp & " "
                    Else
                        temp = temp & "null"
                        temp = temp & " "
                    End If
                Next i

                KP_Pages.Caption = KP_Pages.Caption & vbNewLine & vbNewLine & temp
                
            End If
        Else
            'Wenn der Key keine Pages enthlt, werden keine Daten
            'gelesen oder angezeigt
            MsgBox ("Key is Read-Only")
        End If
    Else
        KP_Pages.Caption = ""
    End If
End Sub
